function varargout = dibuk(varargin)
% Debugs georeferences
%
% Vlad Atanasiu * 01/02/2008
% Last revision > 23/06/2008
%
% atanasiu@mit.edu
% http://mywebpage.netscape.com/atanasiuvlad/

% DIBUK M-file for dibuk.fig
%      DIBUK, by itself, creates a new DIBUK or raises the existing
%      singleton*.
%
%      H = DIBUK returns the handle to a new DIBUK or the handle to
%      the existing singleton*.
%
%      DIBUK('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in DIBUK.M with the given input arguments.
%
%      DIBUK('Property','Value',...) creates a new DIBUK or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before dibuk_Openinbunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to dibuk_Openinbcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the resonse to help dibuk

% Last Modified by GUIDE v2.5 23-Jun-2008 12:53:17

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @dibuk_OpeningFcn, ...
                   'gui_OutputFcn',  @dibuk_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before dibuk is made visible.
function dibuk_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to dibuk (see VARARGIN)

% Choose default command line output for dibuk
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes dibuk wait for user resonse (see UIRESUME)
% uiwait(handles.figure1);
   

% --- Outputs from this function are returned to the command line.
function varargout = dibuk_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;

% ===================================
% READ DATA
% ===================================

% --- Executes on button press in Load_pushbutton.
function Load_pushbutton_Callback(hObject, eventdata, handles)
global data pn co nu nuts encoding

% alert on busy state
bgdcol = get(gcf,'Color');
set(handles.Load_pushbutton,'String','Loading data...',...
    'ForegroundColor',[1 1 1],...
    'BackgroundColor',[1 0 0]);
drawnow

% get encoding from GUI
k = get(handles.Encoding_popupmenu,'Value');
if isempty(k) == 1
    k = 1;
end
encoding = get(handles.Encoding_popupmenu,'String');
encoding = cell2mat(encoding(k));

[filename,pathname] = uigetfile('*.txt');

if filename ~= 0 | pathname ~= 0;
    [path,name,ext,ver] = fileparts([pathname,filename]);
    if strcmp(ext,'.txt') == 1
        try
            % reads data
            data = textscanu(filename, encoding);
        catch
            % error handling    
            errordlg(lasterr,'File Type Error','modal');
            return
        end
    end
end
pn = data(:,1);
co = data(:,2:3);
nu = [];
nuts = [];

% regions codes and boundary data
if size(data,2) > 3
    nu = data(:,4);
    rfile = 'nuts';
    try
        load(rfile)
    catch
        s = [ {'Debuging of outliers will not be possible -'},...
            {['boundary file "',rfile,'.mat" missing.']} ];
        msgbox(s,'Error','warn')
    end
else
    s = [ {'Debuging of outliers will not be possible -'},...
        {['region codes missing.']} ];
    msgbox(s,'Error','warn')
end

% convert coordinates from string to numeric
co = cellfun(@(x) str2double(strrep(x, ',', '.')),...
    co, 'UniformOutput', false);
co = cell2mat(co);

% finis alert on busy state
set(handles.Load_pushbutton,'String','Load data',...
    'ForegroundColor',[0 0 0],...
    'BackgroundColor',bgdcol);
drawnow

% ===================================
% DEBUG
% ===================================

% --- Executes on button press in Debug_pushbutton.
function Debug_pushbutton_Callback(hObject, eventdata, handles)
global data pn co nu nuts encoding

if isempty(pn)
    return
end

% alert on busy state
bgdcol = get(gcf,'Color');
set(handles.Debug_pushbutton,'String','Debuging...',...
    'ForegroundColor',[1 1 1],...
    'BackgroundColor',[1 0 0]);

if get(handles.Variants_checkbox,'Value') == 1
    set(handles.Variants_checkbox,'BackgroundColor',[1 1 0]);
end
if get(handles.Focus_checkbox,'Value') == 1
    set(handles.Focus_checkbox,'BackgroundColor',[1 1 0]);
end
if get(handles.Homonyms_checkbox,'Value') == 1
    set(handles.Homonyms_checkbox,'BackgroundColor',[1 1 0]);
end
if get(handles.Proximity_checkbox,'Value') == 1
    set(handles.Proximity_checkbox,'BackgroundColor',[1 1 0]);
end
if get(handles.Outliers_checkbox,'Value') == 1 && ...
        size(data,2) > 3 && isempty(nuts) == 0
    set(handles.Outliers_checkbox,'BackgroundColor',[1 1 0]);
end
if get(handles.Precision_checkbox,'Value') == 1
    set(handles.Precision_checkbox,'BackgroundColor',[1 1 0]);
end
if get(handles.Deblank_checkbox,'Value') == 1
    set(handles.Deblank_checkbox,'BackgroundColor',[1 1 0]);
end
drawnow

% ----------------------------------------
% Deblank - removes leading, trailing and double spaces
% ----------------------------------------
if get(handles.Deblank_checkbox,'Value') == 1
    % busy on
    set(handles.Deblank_checkbox,...
    'BackgroundColor',[1 0 0]);
    drawnow

    % make readable string
    s = [];
    s = ['Deblank - removes leading, trailing and double spaces\n\n'];
    for k = 1:size(pn,1)
        t = strtrim(cell2mat(pn(k))); % leading and trailing blanks
        while isempty(strfind(t, '  ')) == 0
            t = strrep(t, '  ', ' '); % multiple blanks
        end
        s = [s, t, '\n'];
    end

    % save data
    fid = fopen('dibuk-deblank.txt', 'wt', 'native', encoding);
    fprintf(fid, s);
    fclose(fid);
        
    % busy off
    set(handles.Deblank_checkbox,...
    'BackgroundColor',[0 1 0]);
    drawnow
end

% ----------------------------------------
% Precision - trim number of decimals
% ----------------------------------------
% trimming is first thing to do
if get(handles.Precision_checkbox,'Value') == 1
    % busy on
    set(handles.Precision_checkbox,...
    'BackgroundColor',[1 0 0]);
    drawnow

    % threshold
    thd = str2num(get(handles.Precision_edit,'String'));
    
    % trimmed precision
    f = ['%4.',num2str(thd),'f'];
    co = [str2num(num2str(fix(co(:,1)*10^thd)/10^thd, f)),...
        str2num(num2str(fix(co(:,2)*10^thd)/10^thd, f))];
    
    % make readable string
    s = [];
    s = ['Precision - ',num2str(thd),' decimals\n\n'];
    for k = 1:size(co,1)
        if get(handles.Decimals_popupmenu,'Value') == 1
            % point delimitator
            s = [s, num2str(co(k,1),f), '\t',...
                num2str(co(k,2), f), '\n'];
        else
            % comma delimitator
            s = [s, strrep(num2str(co(k,1),f), '.', ','), '\t',...
                strrep(num2str(co(k,2), f), '.', ','), '\n'];
        end
        
        % save data
        fid = fopen('dibuk-precision.txt', 'wt', 'native', encoding);
        fprintf(fid, s);
        fclose(fid);
    end
    
    % busy off
    set(handles.Precision_checkbox,...
    'BackgroundColor',[0 1 0]);
    drawnow
end

% ----------------------------------------
% Variants - different names, same coordinates
% ----------------------------------------
if get(handles.Variants_checkbox,'Value') == 1
    % busy on
    set(handles.Variants_checkbox,...
    'BackgroundColor',[1 0 0]);
    drawnow

    % find repeated coordinates
    latlon = []; % melt two numerals into one string
    for k = 1:size(co,1)
        latlon = [latlon; {[mat2str(co(k,1)), mat2str(co(k,2))]}];
    end
    u = unique(latlon);
    f = []; % find frequency of each unique latlon pair
    for k = 1:size(u,1)
        f = [f; sum(strcmp(u(k), latlon))];
    end
    v = u(find(f>1));
    vx = []; % find indices
    for k = 1:size(v,1)
        vx = [vx; {find(strcmp(v(k), latlon))}];
    end
    
    % remove all entries w/ just one value per unique coord field
    s = [];
    s = ['Variants - different names, same coordinates\n\n'];
    for k = 1:size(vx,1)
        u = unique(pn(cell2mat(vx(k))));
        if size(u,1) > 1
            n = cell2mat(vx(k));
            % construct readable string
            for m = 1:size(n,1)
                s = [ s, [cell2mat(pn(n(m))), '\t',...
                    mat2str(co(n(m),1)), '\t',...
                    mat2str(co(n(m),2)), '\n'] ];
            end
            s = [s, '\n'];
        end
    end
        
    % save data
    fid = fopen('dibuk-variants.txt', 'wt', 'native', encoding);
    fprintf(fid, s);
    fclose(fid);

    % busy off
    set(handles.Variants_checkbox,...
    'BackgroundColor',[0 1 0]);
    drawnow
end

% ----------------------------------------
% Focus - same names, slightly different coordinates
% ----------------------------------------
if get(handles.Focus_checkbox,'Value') == 1
    % busy on
    set(handles.Focus_checkbox,...
    'BackgroundColor',[1 0 0]);
    drawnow

    % threshold
    th = str2num(get(handles.Focus_edit,'String'));
    
    % find replicated names entries
    u = unique(pn);
    f = []; % find frequency of each unique latlon pair
    for k = 1:size(u,1)
        f = [f; sum(strcmp(u(k), pn))];
    end
    v = u(find(f>1));
    vx = []; % find indices
    for k = 1:size(v,1)
        vx = [vx; {find(strcmp(v(k), pn))}];
    end
    
%     % convert lat-lon coord to a single imaginary number
%     c = co(:,1)+i*co(:,2);
    
    % find coords within a given range
    ix = [];
    for m = 1:size(vx,1) % all replicate names groups
        b = 0;
        g = cell2mat(vx(m)); % indices within group
        for n = 1:size(g,1) % all refrence coords within a group
            for t = n+1:size(g,1) % comparison elements
                d = distance(co(g(n),1),co(g(n),2),...
                    co(g(t),1),co(g(t),2));
%                 d1 = real(abs(c(g(n))-c(g(t)))); % distance longitude
%                 d2 = imag(abs(c(g(n))-c(g(t)))); % distance latiude
                if d <= th && d ~= 0
                    b = 1; % focus
                    ix = [ix; m]; % group indices
                    break
                end
            end
            if b == 1, break, end
        end
    end

    % make readable string
    s = [];
    s = ['Focus - same names, slightly different coordinates ',...
        '(<= ',num2str(th),' decimal degrees)\n\n'];
    for m = 1:size(ix,1)
        g = cell2mat(vx(ix(m)));
         for n = 1:size(g,1)
             s = [s, cell2mat(v(ix(m))), '\t',...
                 num2str(co(g(n),1)), '\t',...
                 num2str(co(g(n),2)), '\n'];
         end
         s = [s, '\n'];
    end
    
    % save data
    fid = fopen('dibuk-focus.txt', 'wt', 'native', encoding);
    fprintf(fid, s);
    fclose(fid);

    % busy off
    set(handles.Focus_checkbox,...
    'BackgroundColor',[0 1 0]);
    drawnow
end


% ----------------------------------------
% Homonyms - same names, sizeable different coordinates
% ----------------------------------------
if get(handles.Homonyms_checkbox,'Value') == 1
    % busy on
    set(handles.Homonyms_checkbox,...
    'BackgroundColor',[1 0 0]);
    drawnow

    % thresold
    th = str2num(get(handles.Homonyms_edit,'String'));
    
    % find replicated names entries
    u = unique(pn);
    f = []; % find frequency of each unique latlon pair
    for k = 1:size(u,1)
        f = [f; sum(strcmp(u(k), pn))];
    end
    v = u(find(f>1));
    vx = []; % find indices
    for k = 1:size(v,1)
        vx = [vx; {find(strcmp(v(k), pn))}];
    end
    
    % find coords within a given range
    ix = [];
    for m = 1:size(vx,1) % all replicate names groups
        b = 0;
        g = cell2mat(vx(m)); % indices within group
        for n = 1:size(g,1) % all refrence coords within a group
            for t = n+1:size(g,1) % comparison elements
                d = distance(co(g(n),1),co(g(n),2),...
                    co(g(t),1),co(g(t),2));
                if d >= th
                    b = 1; % homonyms
                    ix = [ix; m]; % group indices
                    break
                end
            end
            if b == 1, break, end
        end
    end

    % make readable string
    s = [];
    s = ['Homonyms - same names, sizeable different coordinates ',...
        '(>= ',num2str(th),' decimal degrees)\n\n'];
    for m = 1:size(ix,1)
        g = cell2mat(vx(ix(m)));
         for n = 1:size(g,1)
             s = [s, cell2mat(v(ix(m))), '\t',...
                 num2str(co(g(n),1)), '\t',...
                 num2str(co(g(n),2)), '\n'];
         end
         s = [s, '\n'];
    end
    
    % save data
    fid = fopen('dibuk-homonyms.txt', 'wt', 'native', encoding);
    fprintf(fid, s);
    fclose(fid);

    % busy off
    set(handles.Homonyms_checkbox,...
    'BackgroundColor',[0 1 0]);
    drawnow
end

% ----------------------------------------
% Proximity - different names, very close locations
% ----------------------------------------
if get(handles.Proximity_checkbox,'Value') == 1
    % busy off
    set(handles.Proximity_checkbox,...
    'BackgroundColor',[1 0 0]);
    drawnow

% thresold
    th = str2num(get(handles.Proximity_edit,'String'));

    % list of unique coordinates
    % convert lat-lon coord to a single imaginary number
    c = co(:,1)+i*co(:,2);
    [c cix] = unique(c);
    p = pn(cix);

    % loop through all unique coordinates
    gp = [];
    for m = 1:size(c,1)
        for n = m+1:size(c,1)
            if abs(real(c(m))-real(c(n))) > th || ...
                    abs(imag(c(m))-imag(c(n))) > th
                break
            end
            d = distance( real(c(m)),imag(c(m)),...
                real(c(n)),imag(c(n)) );
            % if distance smaller than thresold
            % and different names
            % memorize index of both locations
            if d <= th &&...
                    strcmp(cell2mat(p(m)),...
                    cell2mat(p(n))) == 0
                gp = [gp; m; n];
            end
        end
    end

    % make readable string
    s = [];
    s = ['Proximity - different names, very close locations ',...
        '(<= ',num2str(th),' decimal degrees)\n\n'];
    for k = 1:2:size(gp,1)
        s = [s, [cell2mat(p(gp(k))), '\t',...
            num2str(real(c(gp(k)))), '\t',...
            num2str(imag(c(gp(k)))), '\n',...
            cell2mat(p(gp(k+1))), '\t',...
            num2str(real(c(gp(k+1)))), '\t',...
            num2str(imag(c(gp(k+1)))), '\n\n'],...
            ];
    end

    % save data
    fid = fopen('dibuk-proximity.txt', 'wt', 'native', encoding);
    fprintf(fid, s);
    fclose(fid);

    % busy off
    set(handles.Proximity_checkbox,...
    'BackgroundColor',[0 1 0]);
    drawnow
end

% ----------------------------------------
% Outliers - location outside a given region
% ----------------------------------------
if get(handles.Outliers_checkbox,'Value') == 1 && ...
        isempty(nu) == 0 && isempty(nuts) == 0
    % busy on
    set(handles.Outliers_checkbox,...
    'BackgroundColor',[1 0 0]);
    drawnow

    % list of unique regions
    r = unique(nu);
    if isempty(cell2mat(r(1))) == 1
        r = r(2:end);   % remove empty field
    end
    
    % loop through all regions
    s = [];
    s = ['Outliers - location outside a given region\n\n'];
    for k = 1:size(r,1)
        % get nuts level
        level = length(cell2mat(r(k)))-2;
        level = ['nuts',num2str(level)];
        % get nuts boundary
        t = find(strcmp(nuts.(level).id,r(k)));
        if isempty(t) == 0
            xv = cell2mat(nuts.(level).latitude(t))';
            yv = cell2mat(nuts.(level).longitude(t))';
            rix = find(strcmp(r(k),nu));
            % get outlying locations
            in = inpolygon(co(rix,2),co(rix,1),xv,yv);
            ix = rix(find(~in));
            if isempty(ix) == 0
                for m = 1:size(ix,1)
                    s = [s,...
                        cell2mat(data(ix(m),1)), '\t',...
                        mat2str(co(ix(m),1)), '\t',...
                        mat2str(co(ix(m),2)), '\t',...
                        cell2mat(data(ix(m),4)), '\n'];
                end
                s = [s, '\n'];
            end
        end
    end

    % save data
    fid = fopen('dibuk-outliers.txt', 'wt', 'native', encoding);
    fprintf(fid, s);
    fclose(fid);

    % busy off
    set(handles.Outliers_checkbox,...
    'BackgroundColor',[0 1 0]);
    drawnow
else
    if exist('dibuk-outliers.txt','file')
        delete('dibuk-outliers.txt')
    end
end


% ----------------------------------------
% End debug
% ----------------------------------------
% finish alert on busy state
set(handles.Variants_checkbox,...
    'BackgroundColor',bgdcol);
set(handles.Focus_checkbox,...
    'BackgroundColor',bgdcol);
set(handles.Homonyms_checkbox,...
    'BackgroundColor',bgdcol);
set(handles.Proximity_checkbox,...
    'BackgroundColor',bgdcol);
set(handles.Outliers_checkbox,...
    'BackgroundColor',bgdcol);
set(handles.Precision_checkbox,...
    'BackgroundColor',bgdcol);
set(handles.Deblank_checkbox,...
    'BackgroundColor',bgdcol);

set(handles.Debug_pushbutton,'String','Debug',...
    'ForegroundColor',[0 0 0],...
    'BackgroundColor',bgdcol);
drawnow


% ===================================
% GUI callbacks (additionals)
% ===================================

% --- Executes on button press in Variants_checkbox.
function Variants_checkbox_Callback(hObject, eventdata, handles)

% --- Executes on button press in Focus_checkbox.
function Focus_checkbox_Callback(hObject, eventdata, handles)

% --- Executes on button press in Homonyms_checkbox.
function Homonyms_checkbox_Callback(hObject, eventdata, handles)

% --- Executes on button press in Proximity_checkbox.
function Proximity_checkbox_Callback(hObject, eventdata, handles)

% --- Executes on button press in Outliers_checkbox.
function Outliers_checkbox_Callback(hObject, eventdata, handles)

% --- Executes on button press in Precision_checkbox.
function Precision_checkbox_Callback(hObject, eventdata, handles)

function Precision_edit_Callback(hObject, eventdata, handles)
% Hints: get(hObject,'String') returns contents of Precision_edit as text
%        str2double(get(hObject,'String')) returns contents of Precision_edit as a double

% --- Executes during object creation, after setting all properties.
function Precision_edit_CreateFcn(hObject, eventdata, handles)

function Focus_edit_Callback(hObject, eventdata, handles)

% --- Executes during object creation, after setting all properties.
function Focus_edit_CreateFcn(hObject, eventdata, handles)

function Homonyms_edit_Callback(hObject, eventdata, handles)

% --- Executes during object creation, after setting all properties.
function Homonyms_edit_CreateFcn(hObject, eventdata, handles)

function Outliers_edit_Callback(hObject, eventdata, handles)

% --- Executes during object creation, after setting all properties.
function Outliers_edit_CreateFcn(hObject, eventdata, handles)

function Proximity_edit_Callback(hObject, eventdata, handles)

% --- Executes during object creation, after setting all properties.
function Proximity_edit_CreateFcn(hObject, eventdata, handles)

% --- Executes on selection change in Encoding_popupmenu.
function Encoding_popupmenu_Callback(hObject, eventdata, handles)
%        contents{get(hObject,'Value')} returns selected item from Encoding_popupmenu

% --- Executes during object creation, after setting all properties.
function Encoding_popupmenu_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes on selection change in Decimals_popupmenu.
function Decimals_popupmenu_Callback(hObject, eventdata, handles)
% Hints: contents = get(hObject,'String') returns Decimals_popupmenu contents as cell array
%        contents{get(hObject,'Value')} returns selected item from Decimals_popupmenu

% --- Executes during object creation, after setting all properties.
function Decimals_popupmenu_CreateFcn(hObject, eventdata, handles)
% Hint: popupmenu controls usually have a white background on Windows.
%       See IsC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes on button press in Deblank_checkbox.
function Deblank_checkbox_Callback(hObject, eventdata, handles)


